unit SpiralUlama;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfrmMain = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  // 
  xmin,xmax,ymin,ymax,hight:integer;
  xColor,yColor:Tcolor;
  pp:boolean;
implementation

{$R *.DFM}

function proper(c:real):boolean;
  var l:boolean;d,c0:integer;cc:real;
begin
  cc:=c;
  c0:=succ(trunc(sqrt(cc)));
  l:=true;
  d:=2;
  while l and (d<=c0) do
    begin
      l:=l and (abs(c-(d*int(c/d)))>1e-5);
      d:=d+1;
    end;
  proper:=l
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  frmMain.height:=570;
  frmMain.Width:=550;
  ymin:=10; ymax:=frmMain.Height-45;
  hight:=ymax-ymin;
  xmin:=10; xmax:=xmin+hight;
  xColor:=clblue;
  yColor:=clAqua;
end;

procedure TfrmMain.FormKeyPress(Sender: TObject; var Key: Char);
begin
  application.Terminate
end;

procedure TfrmMain.FormPaint(Sender: TObject);
var i,j,n,m,c:integer;
begin
  frmMain.Canvas.Brush.Color:=clRed;
  frmMain.Canvas.pen.Color:=clblue;
  for i:=0 to frmMain.Width-35 do
  for j:=0 to frmMain.Height-55 do
    frmMain.Canvas.Pixels[i+xmin,j+ymin]:=rgb(510-(i div 8),510-(j div 8),510-(i+j) div 8);
  n:=hight-2;
  c:=n*n;
  m:=succ(n div 2);{ }
  i:=0;
  repeat
    inc(i); //i- 
    for j:=i to n-i+1 do //  i- 
      begin
        if proper(c) then
          frmMain.Canvas.Pixels[i+xmin,j+ymin]:=xColor;
        c:=c-1
      end;
    for j:=i+1 to n-i+1 do //  i- 
      begin
        if proper(c) then
           frmMain.Canvas.Pixels[j+xmin,n-i+1+ymin]:=xcolor;
         c:=c-1
      end;
    for j:=n-i downto i do //  i- 
      begin
        if proper(c) then
          frmMain.Canvas.Pixels[n-i+1+xmin,j+ymin]:=xcolor;
        c:=c-1
      end;
    for j:=n-i downto i+1 do
      //  i- }
      begin
        if proper(c) then
           frmMain.Canvas.Pixels[j+xmin,i+ymin]:=xcolor;
        c:=c-1
      end;
    Application.ProcessMessages; //    
  until i=m;
end;

end.
